from pyASA.asa import ASA
from pyASA.rule import rule_from_cli, random_rule

asa = ASA("192.168.150.2", user="admin", password="cisco")
if asa.test_connection():
    print(asa.acl.get_acls())

    print("Check ACL exists")
    if asa.acl.exists("TESTME"):
        print("Get ACL rule count")
        print(asa.acl.get_rule_count("TESTME"))
        print("Delete ACL")
        asa.acl.delete_rules("TESTME")

    print("Check ACL exists")
    if asa.acl.exists("TROUBLESHOOTING"):
        print("Get ACL rule count")
        print(asa.acl.get_rule_count("TROUBLESHOOTING"))
        print("Delete ACL")
        asa.acl.delete_rules("TROUBLESHOOTING")

    rules = []
    print("Creating rules")
    for port in range(1, 1001):
        rule = random_rule()
        print(rule.to_cli())
        rule.objectid = 0
        rule.position = 0
        rules.append(rule)
        # asa.acl.append_rule("TESTME", rule)
    print("Append rules to ACL")
    asa.acl.append_rules("TESTME", rules)

    if asa.acl.exists("TESTME"):
        print("Getting rules")
        rules = asa.acl.get_rules("TESTME")
        for rule in rules:
            print(rule.to_cli())
            print(rule_from_cli(rule.to_cli()).to_cli())
            assert rule.to_cli() == rule_from_cli(rule.to_cli()).to_cli()
        print("Matching rules")
        matches = asa.acl.match_shadow_rules(rules)
        print(f"Found {len(matches)} rules shadowing other rules")
        for match, content in matches.items():
            print(f"Rule {match} shadows {len(content['matches'])} rule(s)")
            print(content['shadow'].to_cli())
            print("shadows...")
            for rule in content['matches']:
                print(rule.to_cli())

    # for entry in liste:
    #     rule = rule_from_dict(entry["data"])
    #     print(rule.to_cli())
    #     asa.acl.append_rule("TROUBLESHOOTING", rule)

print("END Test")
